#!/usr/bin/env python
"""
_Information on all the active jobs (and their associated streams and streamers)_

T0Mon: this class is used in the front page
"""
from T0.DAS.Database.Oracle.LongResultQuery import LongResultQuery 

class LastRunningRepack(LongResultQuery):
  
    #the query is hard coded because no one else  use it
    #TO DO: split the query: check if it is possible to reuse the code
   sql="""
           SELECT
          repack_job_def.job_id                                   AS job_id,
          streamer.run_id                                         AS run_id,
          repack_job_def.definition_time                          AS def_time,
          COUNT(DISTINCT( repack_job_streamer_assoc.streamer_id)) AS num_streamers,
          stream.name                                             AS stream,
          job_status.status                                       AS job_status
        FROM
          repack_job_def
        JOIN job_status                ON repack_job_def.job_status = job_status.id
        JOIN repack_job_streamer_assoc ON repack_job_def.job_id     = repack_job_streamer_assoc.job_id
        JOIN streamer                  ON streamer.streamer_id      = repack_job_streamer_assoc.streamer_id
        JOIN stream                    ON streamer.stream_id        = stream.id
        WHERE
          repack_job_def.job_status  = 1
        OR repack_job_def.job_status = 2
        GROUP BY
          repack_job_def.job_id,
          repack_job_def.definition_time,
          streamer.run_id,
          stream.name,
          job_status.status
        ORDER BY
          repack_job_def.job_id DESC
"""
     
   def execute(self, uplimit,downlimit, conn = None, transaction = False):
        bindVars = {"uplimit": uplimit,"downlimit": downlimit,}
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        
        return self.formatDict(result) 
   
####################################################################################################
from WMCore.Database.DBFormatter import DBFormatter
class LastRunningRepack_count(DBFormatter):
  sql="""  SELECT COUNT(DISTINCT   repack_job_def.job_id)
        FROM
          repack_job_def
        WHERE
          repack_job_def.job_status  = 1
        OR repack_job_def.job_status = 2 """