#!/usr/bin/env python
"""
_number of streamers currently used in the express process by the input by run _
T0Mon: % in the front page [1 call for every run]
"""

from T0.DAS.Database.Oracle.Stats.NumByRun import NumByRun

class NumExpressStreamersByRun(NumByRun):
    sql="""  SELECT
   run_id, MAX(completed_count) as completed_count,MAX(failed_count) as failed_count
   FROM
    (SELECT
    runid as run_id,
    CASE 
     WHEN status='Success' THEN  count1
     ELSE 0
    END as completed_count,
    CASE
     WHEN status='Failure' THEN count1
     ELSE 0
    END AS failed_count
  FROM
    (SELECT
      s.run_id AS runid,
      js.status,
      COUNT( DISTINCT a.streamer_id ) AS count1
    FROM
      express_job_streamer_assoc a
    INNER JOIN express_job_def jd ON (jd.job_id     = a.job_id)
    INNER JOIN job_status js      ON ( js.id        =jd.job_status )
    INNER JOIN streamer s         ON (a.streamer_id = s.streamer_id AND s.run_id = :runid)
    GROUP BY
      s.run_id,
      js.status
    )) 
 GROUP BY run_id   """
   
    

