#!/usr/bin/env python
"""
_Statistics on Express Merge jobs_
T0Mon: This class is used in frontpage and in every run page for the statistical table
"""

from T0.DAS.Database.Oracle.Stats.StatsRepackMerge import StatsRepackMerge

class StatsExpressMerge(StatsRepackMerge):


   
    sql=""" SELECT COUNT(*) as count,  status from (SELECT DISTINCT j.id,   CASE  
        WHEN js.name='cleanout' and j.outcome=1  THEN 'complete'
        WHEN js.name='cleanout' and j.outcome=0 THEN 'failed' 
        WHEN js.name!='cleanout'   THEN 'acquired'
        else 'error'
END as status
 
FROM     wmbs_job j
INNER JOIN wmbs_jobgroup jg               ON (jg.id             = j.jobgroup )
INNER JOIN wmbs_subscription ws           ON (jg.subscription   = ws.id)
INNER JOIN wmbs_job_state js ON j.state = js.id  %s
WHERE  ws.fileset = (SELECT id FROM wmbs_fileset WHERE name ='ExpressMergeable' )
)
group by status
order by status"""

    sqlRun=""" INNER JOIN wmbs_job_assoc assoc           ON (j.id              = assoc.job) \
    INNER JOIN  wmbs_file_runlumi_map m  ON (assoc.fileid = m.fileid and  m.run = :run) """
    
    def buildQuery(self):
         self.sql=self.sql % (self.sqlRun)