#!/usr/bin/env python
"""
_Statistics on Reco jobs_
if run is not an integer or run<=0 then the statistics are the whole system's ones!!
if run>0 then the statistics are the single run's ones!!
T0Mon: This class is used in frontpage and in every run page for the statistical table
"""


from WMCore.Database.DBFormatter import DBFormatter
from T0.DAS.Database.Oracle.Stats.StatsConstants import fixTables

class StatsReco(DBFormatter):


    sqlFileSet="'Reconstructable'"


    sql="""   SELECT COUNT(*) as count,  status 
from (
SELECT DISTINCT j.id,   CASE  
        WHEN js.name='cleanout' and j.outcome=1  THEN 'complete'
        WHEN js.name='cleanout' and j.outcome=0 THEN 'failed' 
        WHEN js.name!='cleanout'   THEN 'acquired'
        else 'error'
END as status
 
FROM   wmbs_job j
INNER JOIN wmbs_job_state js ON j.state = js.id 
INNER JOIN  wmbs_jobgroup jg ON (jg.id = j.jobgroup ) %s
 WHERE jg.subscription =   ( SELECT id FROM  wmbs_fileset WHERE name = %s )
)
group by status
order by status"""
  
    #sqlRunCountIndex="DISTINCT j.id"
    #sqlGeneralCountIndex="1" #optimization
    
    
    #sqlOutcome="AND j.outcome       = %d"
    #sqlState={tableSuffixes[0]: "!=", # acquired jobs area anything but NOT 'cleanout'
              #tableSuffixes[1]:"=",tableSuffixes[2]:"="} # failed or success jobs are 'cleanout'
    
    sqlRun="""INNER JOIN wmbs_job_assoc assoc           ON (j.id              = assoc.job)
                 INNER JOIN  wmbs_file_runlumi_map m  ON (assoc.fileid = m.fileid and  m.run = :run) """
   
    def execute(self, run, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given  statistics and then format and return
        the result.
        """
        bindVars={}

        try:
          if int(run)>0:
           self.sql=self.sql % (self.sqlRun,self.sqlFileSet)
           bindVars = {"run": run}
          else: 
            raise Exception('zeroRun')
        except Exception:
            self.sql=self.sql % ("",self.sqlFileSet)
        #print self.sql
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
        #service={'status': table}
        #if printSQL:
          #service = dict(service.items()+{'sql': self.sql}.items())
        return fixTables(self.formatDict(result))
        #return self.formatDict(result)