#!/usr/bin/env python
"""
_Statistics on Repack Merge jobs_
if run is not an integer or run<=0 then the statistics are the whole system's ones!!
if run>0 then the statistics are the single run's ones!!
T0Mon: This class is used in frontpage and in every run page for the statistical table

"""
__all__ = []
__revision__ = "$Id: StatsRepackMerge.py,v 1.5 2010/11/04 15:03:11 dzambon Exp $"
__version__ = "$Revision: 1.5 $"

from WMCore.Database.DBFormatter import DBFormatter
from T0.DAS.Database.Oracle.Stats.StatsConstants import fixTables
#from T0.DAS.Database.Oracle.Stats.StatsConstants import printSQL

class StatsRepackMerge(DBFormatter):
    
    sqlFileSet="'Mergeable'"
    dataTier="'RAW'"
    
    sql="""  SELECT COUNT(*) as count,  status 
from (
SELECT DISTINCT j.id,   CASE  
        WHEN js.name='cleanout' and j.outcome=1  THEN 'complete'
        WHEN js.name='cleanout' and j.outcome=0 THEN 'failed' 
        WHEN js.name!='cleanout'   THEN 'acquired'
        else 'error'
END as status
 
FROM   wmbs_job j
INNER JOIN wmbs_job_assoc assoc          ON (j.id              = assoc.job)
INNER JOIN wmbs_job_state js ON j.state = js.id 
INNER JOIN wmbs_jobgroup jg              ON (jg.id = j.jobgroup ) 
INNER JOIN wmbs_subscription ws          ON (jg.subscription = ws.id) 
INNER JOIN  wmbs_file_details            ON  wmbs_file_details.id                         =  assoc.fileid
INNER JOIN  wmbs_file_dataset_path_assoc ON  wmbs_file_details.id                         =  wmbs_file_dataset_path_assoc.file_id
INNER JOIN  dataset_path                 ON  wmbs_file_dataset_path_assoc.dataset_path_id =  dataset_path.id  %s
 WHERE  dataset_path.data_tier =      (SELECT   data_tier.id FROM data_tier WHERE data_tier.name = %s  )
AND ws.fileset =  (SELECT id FROM wmbs_fileset WHERE name = %s ))
group by status
order by status"""
    
  

    sqlRun="""    INNER JOIN  wmbs_file_runlumi_map m  ON (assoc.fileid = m.fileid and  m.run = :run)  """
    
  
            
    def buildQuery(self):
        self.sql=self.sql % (self.sqlRun,self.dataTier,self.sqlFileSet)
        
    def execute(self, run, conn = None, transaction = False):
        """
        _execute_

        Execute the SQL for the given  statistics and then format and return
        the result.
        """
        bindVars={}
        try:
          if int(run)>0:
           self.buildQuery()
           bindVars = {"run": run}
          else: 
            raise Exception('zeroRun')
        except Exception:
           self.sqlRun=""
           self.buildQuery()
        #print self.sql
        result = self.dbi.processData(self.sql, bindVars, conn = conn,
                                      transaction = transaction)
 
        return fixTables(self.formatDict(result))
          