#!/usr/bin/env python
"""
_InsertRepacked_

Functions for inserting details about a repacked file.
"""

__revision__ = "$Id: InsertRepacked.py,v 1.30 2010/03/08 19:46:22 hufnagel Exp $"
__version__ = "$Revision: 1.30 $"

import logging

def repackedStreamerAssoc(dbConn, jobID, repackedID):
    """
    _repackedStreamerAssoc_

    Create a link between a repacked file and all the streamer files that
    were used in its creation.
    """
    streamerQuery = """INSERT INTO repack_streamer_assoc (repacked_id, streamer_id)
                       SELECT :repackedID, streamer_id FROM repack_job_streamer_assoc
                       WHERE job_id = :jobID
                       GROUP BY streamer_id"""

    bindVars = {"repackedID": repackedID, "jobID": jobID}
    dbConn.execute(streamerQuery, bindVars)
    return

def expressStreamerAssoc(dbConn, jobID, expressID):
    """
    _expressStreamerAssoc_
    
    Create a link between a expressed file and all the streamer files that
    were used in its creation.
    To do: this need to be changed if express process create more than one 
    file. (ie dataset then use something like repacked streamer assoc)
    """
    streamerQuery = """INSERT INTO repack_streamer_assoc (repacked_id, streamer_id)
                       SELECT :expressID, streamer_id FROM express_job_streamer_assoc
                       WHERE job_id = :jobID
                       GROUP BY streamer_id"""

    bindVars = {"expressID": expressID, "jobID": jobID}
    dbConn.execute(streamerQuery, bindVars)
    return
