
import logging

from T0.Tier0Accountant.JobHandlerInterface import JobHandlerInterface
from T0.State.Database.Writer import InsertStreamer

class MCStreamer(JobHandlerInterface):
    """
    _MCStreamer_
    
    Job handler for T0 NC Feed for streamer
    It only updates streamer table on the job success
    """
    def handleSuccessfulJob(self, jobInfo, jobFiles):
        """
        _handleSuccessfulJob_
        
        jobFiles param contains list of StreamerFile structure 
        """
        InsertStreamer.insertStreamers(self.t0astDBConn, jobFiles)

    def handleFailedJob(self, jobInfo):
        """
        _handleFailedJob_
        
        currently not doing anything on failed job
        """
        pass
