#!/usr/bin/env python
"""
_PromptCalib_

Job handler for PromptCalib jobs.
"""
__revision__ = "$Id: PromptCalib.py,v 1.2 2010/01/22 13:41:07 naderer Exp $"
__version__ = "$Revision: 1.2 $"

import logging


from T0.Tier0Accountant.WMBSBaseHandler import WMBSBaseHandler


class PromptCalib(WMBSBaseHandler):
    """
    _PromptCalib_

    Job handler for PromptCalib jobs,
    only need to update job status.
    """
    
    def handleSuccessfulJob(self, jobInfo, jobFiles):
        """
        _handleSuccessfulJob_

        Currently PromptCalib job needs only state update.
        """
        
        logging.debug("PromptCalibHandler handles successful job ID:%s"  
                      % jobInfo["JOB_IDENTIFIER"])
        
        WMBSBaseHandler.handleSuccessfulJob(self, jobInfo, jobFiles)
        
        return
    

